package fr.nitorac.aurionweb.aurionweb;

import android.content.Context;
import android.os.AsyncTask;

import com.afollestad.materialdialogs.LayoutMode;
import com.afollestad.materialdialogs.MaterialDialog;
import com.afollestad.materialdialogs.bottomsheets.BottomSheet;
import com.afollestad.materialdialogs.customview.DialogCustomViewExtKt;

import java.security.GeneralSecurityException;
import java.util.function.Consumer;

import fr.nitorac.aurionweb.R;

public class CheckConnectionTask extends AsyncTask<AurionCred, Void, Boolean> {

    private MaterialDialog loading;
    private Consumer<Boolean> callback;
    private Consumer<AurionSession> networkStuff;
    private AurionSession session;

    public CheckConnectionTask(Context c, Consumer<Boolean> callback){
        this(c, new AurionSession(), callback, (ign) -> {});
    }

    public CheckConnectionTask(Context c, AurionSession session, Consumer<Boolean> callback, Consumer<AurionSession> networkStuff){
        this.callback = callback;
        this.networkStuff = networkStuff;
        this.session = session;
        loading = new MaterialDialog(c, new BottomSheet(LayoutMode.WRAP_CONTENT))
            .cancelable(false)
            .cancelOnTouchOutside(false)
            .title(R.string.loading, null)
            .noAutoDismiss();
        DialogCustomViewExtKt.customView(loading, R.layout.dialog_loading, null, false, false, true, true);
        loading.dismiss();
    }

    @Override
    protected void onPreExecute() {
        super.onPreExecute();
        loading.show();
    }

    @Override
    protected void onPostExecute(Boolean res) {
        super.onPostExecute(res);
        loading.dismiss();
        callback.accept(res);
    }

    @Override
    protected Boolean doInBackground(AurionCred... cred) {
        try {
            boolean res = AurionManager.getInstance().checkPassword(session, cred[0]);
            networkStuff.accept(session);
            return res;
        } catch (GeneralSecurityException e) {
            e.printStackTrace();
            return false;
        }
    }
}
